#!/bin/bash
MYFILE=~/Scripts/F-ilter/badWords
MYLOG=~/Scripts/F-ilter/F-ilter.log

# nuke the log if getting too big (> 500K)
touch $MYLOG
eval $(stat -s F-ilter.log)
if [ "$st_size" -gt 50 ]; then
echo $st_size  
rm $MYLOG #2> /dev/null
fi
index=0
if ps x | grep iTunes | grep -q -v grep;   then

# load array
  while read line ; do
  	MYARRAY[$index]="$line"
	index=$(($index+1))
  done < $MYFILE


  while [ "1" != "2" ] # easy way to get into infinite loop
  do
    SKIPPED=0
    # Check lyrics against list of bad words
    for NAME in ${MYARRAY[@]}
    do
      MYNB=$(grep $NAME /tmp/currentlyplaying.temp | wc -l 2>/dev/null)
      if [ "$MYNB" -gt 0 ]; then
        TRACK_INFO=$(osascript -e ' 
  	  tell application "iTunes"
            set artistname to artist of current track
            set trackname to name of current track
            set outputsave to artistname & " (" & trackname & ")"
            next track
            say "track skipped"
            set output to outputsave
	  end tell'   | iconv -f utf-8 -t ucs-2-internal)
        echo "$(date) -- skipped $TRACK_INFO (lyrics)" >> $MYLOG
        SKIPPED=1
        break
      fi
    done

    if [ "$SKIPPED" = 0 ]; then
      # Check GROUPING field in iTunes for flagged tracks
      TRACK_INFO=
      TRACK_INFO=$(osascript -e 'tell application "iTunes"
        if player state is playing then
          set mygrouping to grouping of current track
          if mygrouping = "F-ilter"
            set artistname to artist of current track
            set trackname to name of current track
            set outputsave to artistname & " (" & trackname & ")"
            say "track skipped"
            next track
            set ouput to outputsave
          end if
        end if         
      end tell' | iconv -f utf-8 -t ucs-2-internal)
      if [ "$TRACK_INFO" != "" ]; then
        echo "$(date) -- skipped $TRACK_INFO (grouping)" >> $MYLOG
      fi
    fi
  
    sleep 2
    done
    
fi
